> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Product Variant Metafield

POST https://api.bigcommerce.com/stores/{store_hash}/v3/catalog/products/{product_id}/variants/{variant_id}/metafields
Content-Type: application/json

Creates a product variant *Metafield*.

**Required Fields:**
* permission_set
* namespace
* key
* value

**Read-Only Fields**
* id

**Note:** The maxiumum number of metafields allowed on each order, product, category, variant, or brand is 250 per client ID. For more information, see [Platform Limits](https://support.bigcommerce.com/s/article/Platform-Limits) in the Help Center.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/catalog/product-variants/metafields/create-product-variant-metafield

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Products | modify | `store_v2_products` | | Products | read-only | `store_v2_products_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `product_id` (integer, required) — The ID of the `Product` to which the resource belongs. Product variant metafield endpoints that have the `product_id` in the request path are successful as long as the parameter is not empty. The `product_id` segment is there only for path consistency.
- `variant_id` (integer, required) — ID of the variant on a product, or on an associated Price List Record.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a metafield_Base.

- `key` (string, required) — The name of the field, for example: `location_id`, `color`. Required for POST.
- `value` (string, required) — The value of the field, for example: `1`, `blue`. You must enter a JSON formatted string for [ShipperHQ](/developer/docs/admin/store-configuration/shipping/shipper-hq#shipperhq-object-properties) metafields. Required for POST.
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes. This is set by the developer. Required for POST.
- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. |Value|Description |-|-| |`app_only`|Private to the app that owns the field| |`read`|Visible to other API consumers| |`write`|Open for reading and writing by other API consumers| |`read_and_sf_access`|Visible to other API consumers, including on storefront| |`write_and_sf_access`|Open for reading and writing by other API consumers, including on storefront|
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `description` (string, optional) — Description for the metafields.

## Response

### 200

OK

- `data` (metafield_Full, optional)
- `meta` (metaEmpty_Full, optional) — Response metadata.

## Errors

### 400 Bad Request Error

Bad Request. Input is invalid.

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `detail` (string, optional)

### 409 Conflict Error

The `Metafield` was in conflict with another `Metafield`. This can be the result of duplicate unique-key combinations of the appʼs client id, namespace, key, resource_type, and resource_id.

- `errors` (CatalogProductsProductIdVariantsVariantIdMetafieldsPostResponsesContentApplicationJsonSchemaErrors, optional)
- `instance` (string, optional)
- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)

### 422 Unprocessable Entity Error

The `Metafield` was not valid. This is the result of missing required fields, or of invalid data. See the response for more details.

- `errors` (CatalogProductsProductIdVariantsVariantIdMetafieldsPostResponsesContentApplicationJsonSchemaErrors, optional)
- `instance` (string, optional)
- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)

## Types

### metafield_Full

- `key` (string, required) — The name of the field, for example: `location_id`, `color`. Required for POST.
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes. This is set by the developer. Required for POST.
- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. |Value|Description |-|-| |`app_only`|Private to the app that owns the field| |`read`|Visible to other API consumers| |`write`|Open for reading and writing by other API consumers| |`read_and_sf_access`|Visible to other API consumers, including on storefront| |`write_and_sf_access`|Open for reading and writing by other API consumers, including on storefront|
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `value` (string, required) — The value of the field, for example: `1`, `blue`. You must enter a JSON formatted string for [ShipperHQ](/developer/docs/admin/store-configuration/shipping/shipper-hq#shipperhq-object-properties) metafields. Required for POST.
- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation. Read-Only.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated. Read-Only.
- `description` (string, optional) — Description for the metafields.
- `id` (integer, optional) — Unique ID of the *Metafield*. Read-Only.
- `resource_id` (integer, optional) — The ID of the resource with which the metafield is associated.
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `category`, `brand`, `product`, `variant`

### metaEmpty_Full

Response metadata.

### CatalogProductsProductIdVariantsVariantIdMetafieldsPostResponsesContentApplicationJsonSchemaErrors

## Examples

**Request**

```json
{
  "key": "location_id",
  "value": "Shelf 3, Bin 5",
  "namespace": "App Namespace",
  "permission_set": "app_only",
  "description": "Where products are located"
}
```

**Response**

```json
{
  "data": {
    "key": "location_id",
    "namespace": "App Namespace",
    "permission_set": "app_only",
    "value": "Shelf 3, Bin 5",
    "date_created": "2021-08-06T19:15:35+00:00",
    "date_modified": "2021-08-06T19:15:35+00:00",
    "description": "Where products are located",
    "id": 4,
    "resource_id": 137,
    "resource_type": "variant"
  },
  "meta": {}
}
```

**SDK Code**

```python Create a variant metafield
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields"

payload = {
    "key": "location_id",
    "value": "Shelf 3, Bin 5",
    "namespace": "App Namespace",
    "permission_set": "app_only",
    "description": "Where products are located"
}
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create a variant metafield
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '{"key":"location_id","value":"Shelf 3, Bin 5","namespace":"App Namespace","permission_set":"app_only","description":"Where products are located"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create a variant metafield
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields"

	payload := strings.NewReader("{\n  \"key\": \"location_id\",\n  \"value\": \"Shelf 3, Bin 5\",\n  \"namespace\": \"App Namespace\",\n  \"permission_set\": \"app_only\",\n  \"description\": \"Where products are located\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create a variant metafield
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"key\": \"location_id\",\n  \"value\": \"Shelf 3, Bin 5\",\n  \"namespace\": \"App Namespace\",\n  \"permission_set\": \"app_only\",\n  \"description\": \"Where products are located\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create a variant metafield
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"key\": \"location_id\",\n  \"value\": \"Shelf 3, Bin 5\",\n  \"namespace\": \"App Namespace\",\n  \"permission_set\": \"app_only\",\n  \"description\": \"Where products are located\"\n}")
  .asString();
```

```php Create a variant metafield
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields', [
  'body' => '{
  "key": "location_id",
  "value": "Shelf 3, Bin 5",
  "namespace": "App Namespace",
  "permission_set": "app_only",
  "description": "Where products are located"
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Create a variant metafield
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"key\": \"location_id\",\n  \"value\": \"Shelf 3, Bin 5\",\n  \"namespace\": \"App Namespace\",\n  \"permission_set\": \"app_only\",\n  \"description\": \"Where products are located\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create a variant metafield
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "key": "location_id",
  "value": "Shelf 3, Bin 5",
  "namespace": "App Namespace",
  "permission_set": "app_only",
  "description": "Where products are located"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```